<?lsp
-- Slideshow engine receipt:

-- 1: Download a web-site template such as:
-- http://www.freelayouts.com/templates/view/4409

-- 2: Inject LSP into the template (the easy part)

-- 3: Write the slides (the hard part)

local appio = app.io

function send404(msg)
   response:senderror(404,"<h1 style='color:red'>"..msg.."</h1>")
end

local theSlidesFile = page.iodir.."slides.txt"
local st = appio:stat(theSlidesFile)
if not st then
   send404("Cannot find "..theSlidesFile)
   return
end

-- Load and extract slides if the cached version has expired.
if page.slideCache ~= st.mtime then
   page.slides = {}
   -- Load the slides.txt file
   local h=appio:open(theSlidesFile,"rb")
   if h then slidesStr=h:read"*a" ; h:close() end
   if not slidesStr then
      send404("Cannot open "..theSlidesFile)
      return
   end
   -- extract slides from slides.txt
   slidesStr = string.gsub(slidesStr, '\r\n', '\n')  -- DOS is a pain
   string.gsub(slidesStr, "%s*([^\n]*%S)%s*\n?",
               function (s)
                  table.insert(page.slides, s)
               end)
   page.slideCache = st.mtime
end

local maxSlides=table.getn(page.slides); -- Get table size
-- Extract url encoded data "slide" and convert to number
local slideno = tonumber(request:data().slide) or 1
-- Make sure slide number is within the accepted range
if slideno < 1 or slideno > maxSlides then
   slideno = 1;
end

-- Extract the slide header from the slide file name
-- Strip off the leading path, if any.
local header = string.match(page.slides[slideno], ".*/([^/]*)$") or page.slides[slideno]
-- Strip off the file extension 
header = string.gsub(header, "[\.].*$","")
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
    <link href="style.css" rel="stylesheet" type="text/css" />
    <title><?lsp=("Slide "..slideno..": "..header)?></title>
  </head>
  <body>
    <div style="position:fixed;width:auto;margin-right:15px;">
      <?lsp if slideno ~= 1 then ?><a href="?slide=<?lsp=slideno-1?>"><img src="images/nav_prev.gif" border="0" style="float:left;"/></a><?lsp end ?>
      <?lsp if slideno ~= maxSlides then ?><a href="?slide=<?lsp=slideno+1?>"><img src="images/nav_next.gif" border="0" style="float:right;"/></a><?lsp end ?>
   </div>
   <table cellpadding="0" cellspacing="0" border="0" align="center">
     <tr>
       <td width='608px' height='24px' style='background:url(&quot;images/top.jpg&quot;);'>&nbsp;	</td>
     </tr>
     <tr>
       <td width='608px' height='12px' style='background:url(&quot;images/bg.jpg&quot;);'>
         <h1><?lsp=header?></h1>
       </td>
     </tr>
     <tr>
       <td width='608px' height='111px' style='background:url(&quot;images/banner.jpg&quot;);'>&nbsp;	</td>
     </tr>
     <tr valign="top" align="left">
       <td width='608px' height='580px' style='background:url(&quot;images/bg.jpg&quot;);'>
         <font style='font-size:8px'><br /></font>
         <div style="margin: 0 1.5em 0 1.5em">
           <?lsp
           if not response:include(page.slides[slideno]) then
              send404("Cannot find slide: '"..page.slides[slideno].."'")
              return;
           end
           ?>
         </div>
       </td>
     </tr>
     <tr>
       <td width='608px' height='29px' style='background:url(&quot;images/bottom.jpg&quot;);'>
       </td>
     </tr>
   </table>
   <p class='copyright'>
     Powered by <a href='http://barracudaserver.com/pr/lsp.html'>Lua Server Pages</a>
   </p>
  </body>
</html>
